Subject: Re: [PATCH v2] tools/perf: Fix the mask in regs_dump__printf and

From: "Wangnan (F)" <[email-masked]>
Date: Mon, 20 Jun 2016 17:27:25 +0800

On 2016/6/20 17:18, Jiri Olsa wrote:
> On Mon, Jun 20, 2016 at 02:14:01PM +0530, Madhavan Srinivasan wrote:
>> When decoding the perf_regs mask in regs_dump__printf(),
>> we loop through the mask using find_first_bit and find_next_bit functions.
>> "mask" is of type "u64", but sent as a "unsigned long *" to
>> lib functions along with sizeof(). While the exisitng code works fine in
>> most of the case, the logic is broken when using a 32bit perf on a
>> 64bit kernel (Big Endian). We end up reading the wrong word of the u64
>> first in the lib functions.
> hum, I still don't see why this happens.. why do we read the
> wrong word in this case?

If you read a u64 using (u32 *)(&val)[0] and (u32 *)(&val)[1]
you can get wrong value. This is what _find_next_bit() is doing.

In a big endian environment where 'unsigned long' is 32 bits
long, "(u32 *)(&val)[0]" gets upper 32 bits, but without this patch
perf assumes it gets lower 32 bits. The root cause is wrongly convert
u64 value to bitmap.

Thank you.